def moze_sastaviti_kvadrat(shibice, stranica_kvadrata, trenutna_stranica, indeks):
    if trenutna_stranica == 4:
        return True

    for i in range(indeks, len(shibice)):
        if shibice[i] > 0 and shibice[i] <= stranica_kvadrata:
            shibice[i] = 0  # Oznaci šibicu kao korišcenu

            if moze_sastaviti_kvadrat(shibice, stranica_kvadrata, trenutna_stranica + 1, i + 1):
                return True

            shibice[i] = stranica_kvadrata  # Vrati šibicu

    return False

def proveri_kvadrat(shibice):
    ukupna_duzina = sum(shibice)

    if ukupna_duzina % 4 != 0:
        return 0

    stranica_kvadrata = ukupna_duzina // 4
    return 1 if moze_sastaviti_kvadrat(shibice, stranica_kvadrata, 0, 0) else 0

# Ucitavanje broja šibica
n = int(input("Unesite broj šibica: "))

# Ucitavanje dužina šibica
shibice = []
for _ in range(n):
    duzina = int(input("Unesite dužinu šibice: "))
    shibice.append(duzina)

# Provera da li se može sastaviti kvadrat i ispisivanje rezultata
print(proveri_kvadrat(shibice))