#include <iostream>
#include <cmath>

int main() {
    // Unos intervala
    int a, b, c, d;
    std::cin >> a >> b >> c >> d;

    // Pronalaženje tacke gde vrapac treba da sleti
    int vrapac_sleteo;

    if (b <= c) {
        vrapac_sleteo = b;  // Ako je interval [a, b] potpuno levo od intervala [c, d]
    } else if (a >= d) {
        vrapac_sleteo = a;  // Ako je interval [a, b] potpuno desno od intervala [c, d]
    } else {
        vrapac_sleteo = std::max(a, std::min(b, d));  // Inace, sleti na sredinu intervala [a, b] unutar [c, d]
    }

    // Racunanje najveceg rastojanja
    int najvece_rastojanje = std::min(std::abs(vrapac_sleteo - a), std::abs(vrapac_sleteo - b));

    // Ispis rezultata
    std::cout << najvece_rastojanje << std::endl;

    return 0;
}