#include <iostream>

long long countDivisors(long long n) {
    long long divisors = 0;
    for (long long i = 1; i * i <= n; ++i) {
        if (n % i == 0) {
            divisors += (i * i == n) ? 1 : 2;
        }
    }
    return divisors;
}

long long findMinM(long long n) {
    for (long long m = 1;; ++m) {
        long long product = n * m;

        // Provera da li je broj delilaca neparan
        if (countDivisors(product) % 2 == 1) {
            return m;  // Ako je broj delilaca neparan, m je pronaden
        }
    }
}

int main() {
    // Unos broja n
    long long n;

    std::cin >> n;

    // Pronalaženje najmanjeg m
    long long minM = findMinM(n);

    // Ispis rezultata
    std::cout << minM << std::endl;

    return 0;
}