def generisi_raspored(k, rezultati):
    # Funkcija koja generiše raspored igraca na osnovu rezultata meceva
    
    # Broj igraca na pocetku
    broj_igraca = 2 ** k
    
    # Lista koja cuva igrace koji su trenutno u igri
    trenutni_igraci = list(range(broj_igraca))
    
    # Lista koja cuva igrace koji su ispadali u prethodnim rundama
    ispadanje = []
    
    # Petlja koja simulira odigravanje meceva
    for _ in range(k):
        # Nova lista za trenutni krug
        nova_runda = []
        
        # Iteriramo kroz meceve
        for i in range(0, len(trenutni_igraci), 2):
            pobednik, gubitnik = rezultati.pop(0)
            
            # Dodajemo pobednika u novu rundu
            nova_runda.append(pobednik)
            
            # Dodajemo gubitnika u listu ispadanja
            ispadanje.append(gubitnik)
        
        # Trenutni igraci postaju igraci koji su pobedili u ovoj rundi
        trenutni_igraci = nova_runda
    
    # Pobednik je poslednji preostali igrac
    pobednik = trenutni_igraci[0]
    
    # Drugoplasirani je gubitnik finala
    drugoplasirani = ispadanje[0]
    
    # Ispisujemo rezultate
    print(pobednik)
    print(drugoplasirani)
    
    # Ispisujemo ispadanje igraca u prethodnim rundama
    for i in range(k - 1, 0, -1):
        runda_igraci = ispadanje[:2 ** i]
        ispadanje = ispadanje[2 ** i:]
        print(*runda_igraci)

# Testiranje sa primerima
k = int(input())
rezultati = []
for _ in range(2 ** k - 1):
    rezultat = list(map(int, input().split()))
    rezultati.append(rezultat)

generisi_raspored(k, rezultati)