def flip_nth(binary: list[int], nth: int) -> str:
    flipped_binary = []
    for i, bit in enumerate(binary):
        if (i+1) % nth == 0:
            flipped_binary.append(1 if bit == 0 else 0)
        else:
            flipped_binary.append(bit)
    return flipped_binary

def count_changes(arr: list):
    changes = 0
    for i in range(0, len(arr)-1):
        if arr[i] != arr[i+1]:
            changes += 1
    return changes

internet_price = [int(x) for x in list(input())]
flipped_prices = []
for i in range(1, len(internet_price)+1):
    flipped_prices.append((count_changes(flip_nth(internet_price, i)), i))

minimum = min(flipped_prices)

print(minimum[1], minimum[0])