#include <bits/stdc++.h>
using namespace std;

struct lopta {
    float x, y = 0;
    bool predjena = false;
};

lopta lopte[20];
int redosled[20];
int n;

// funkcija koja je true ako su sve predjene a false ako nisu
bool sve_predjene() {
    for(int i = 0; i < n; i++) {
        if(lopte[i].predjena == false)
            return false;
    }
    return true;
}

// rastojanje izmedju dve lopte
float rastojanje(lopta& a, lopta& b) {
    return sqrt(pow(a.x - b.x, 2) + pow(a.y - b.y, 2));
}

int main() {
    // ulaz i izracunavanje x, y koordinate lopta
    cin >> n;
    int najlevija = -1;
    for(int i = 0; i < n; i++) {
        float masa;
        cin >> lopte[i].y >> masa;
        lopte[i].x = static_cast<float>(126) / masa;

        if(najlevija == -1 || lopte[i].x < lopte[najlevija].x)
            najlevija = i;
    }
    // ispisi sve za debuging
    //for(int i = 0; i < n; i++) {
    //    cout << lopte[i].x << " " << lopte[i].y << endl;
    //}

    // dok sve nisu predjene
    int indeks_redosled = 1;
    int trenutna_lopta = najlevija;
    lopte[trenutna_lopta].predjena = true;
    redosled[0] = trenutna_lopta;
    while(!sve_predjene()) {
        // nadji loptu sa najmanjem rastojanjem od trenutne a da nije predjena
        int lopta_njm_rastojanje = -1;
        float njm_rastojanje_lopte = INT_MAX;
        for(int i = 0; i < n; i++) {
            if(i == trenutna_lopta || lopte[i].predjena == true)
                continue;

            float trenutno_rastojanje = rastojanje(lopte[i], lopte[trenutna_lopta]);
            if(lopta_njm_rastojanje == -1 || trenutno_rastojanje < njm_rastojanje_lopte) {
                njm_rastojanje_lopte = trenutno_rastojanje;
                lopta_njm_rastojanje = i;
            }
        }

        // idi ka toj lopti
        redosled[indeks_redosled] = lopta_njm_rastojanje;
        lopte[lopta_njm_rastojanje].predjena = true;

        trenutna_lopta = lopta_njm_rastojanje;
        indeks_redosled++;
    }

    // izlaz
    for(int i = 0; i < n; i++) {
        cout << redosled[i] + 1 << " ";
    }
}