#include <bits/stdc++.h>
using namespace std;

char matrica[250][250]; // :)

struct vec2 {
    int x = 0;
    int y = 0;
};

int broj_teleporta = 0;
vec2 teleporti[50000];
vec2 pocetak;
vec2 cilj;

// :)
inline int broj_koraka(const vec2& a, const vec2& b) {
    return abs(a.x - b.x) + abs(a.y - b.y);
}

int main() {
    // :3
    std::ios::sync_with_stdio(false);

    int n, m;
    cin >> n >> m;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            char c;
            cin >> c;
            matrica[i][j] = c;
            if(matrica[i][j] == 'C') {
                // cilj :D
                cilj.y = i;
                cilj.x = j;
            } else if (matrica[i][j] == 'T') {
                // teleport :D
                teleporti[broj_teleporta].y = i;
                teleporti[broj_teleporta].x = j;
                broj_teleporta++;
            } else if (matrica[i][j] == 'S') {
                // pocetak :D
                pocetak.y = i;
                pocetak.x = j;
            }
        }
    }

    int teleport_pocetak = INT_MAX;
    int teleport_cilj = INT_MAX;
    int pocetak_cilj = INT_MAX;
    pocetak_cilj = broj_koraka(pocetak, cilj);
    for(int i = 0; i < broj_teleporta; i++) {
        int ovaj_teleport_pocetak = broj_koraka(teleporti[i], pocetak);
        if(ovaj_teleport_pocetak < teleport_pocetak)
            teleport_pocetak = ovaj_teleport_pocetak;
        int ovaj_teleport_cilj = broj_koraka(teleporti[i], cilj);
        if(ovaj_teleport_cilj < teleport_cilj)
            teleport_cilj = ovaj_teleport_cilj;
    }
    int najmanji_broj_koraka = min(teleport_pocetak + teleport_cilj, pocetak_cilj);
    cout << najmanji_broj_koraka << endl;
    return 0;
}