def organizuj_turnir(k, rezultati):
    pobednici = set(range(2**k))
    plasman = []

    for _ in range(k):
        sledeci_krug = set()
        for pobednik, gubitnik in rezultati:
            if pobednik in pobednici and gubitnik in pobednici:
                sledeci_krug.add(pobednik)
                pobednici.remove(gubitnik)

        plasman.append(pobednici)
        pobednici = sledeci_krug

    return plasman

def main():
    k = int(input("Unesite broj kol? na turniru: "))
    rezultati = [tuple(map(int, input("Unesite rezultat meca  ").split())) for _ in range(2**k - 1)]

    plasman = organizuj_turnir(k, rezultati)

    print(plasman[-1].pop())
    
    print(plasman[-1].pop())

    for runda in plasman[-2::-1]:
        for igrac in runda:
            print(igrac)

if __name__ == "__main__":
    main()