#include <bits/stdc++.h>
using namespace std;

bool backtrack(vector<int> &sibice, vector<int> vis, int meta, int sum, int i, int k)
{
    if (k==1)
        return true;
    if (sum==meta)
        return backtrack(sibice, vis, meta, 0, 0, k-1);

    for (int j=i; j<sibice.size(); j++)
    {
        if (vis[j] || sum+sibice[j]>meta)
            continue;

        vis[j]=true;

        if (backtrack(sibice, vis, meta, sum+sibice[j], j+1, k))
            return true;

        vis[j]=false;
    }

    return false;
}
bool kvadrat(vector<int> &sibice)
{
    vector<int> vis(sibice.size(), false);
    int sum = 0;

    for (auto x : sibice)
        sum += x;

    if (sibice.size()<4 || sum%4!=0)
        return false;

    return backtrack(sibice, vis, sum / 4, 0, 0, 4);
}

int main()
{
    int n;
    vector <int> sibice;
    cin >> n;
    for (int i=0; i<n; i++){
        int br;
        cin >> br;
        sibice.push_back(br);
    }
    if (kvadrat(sibice)){
        cout << "1" << endl;
    }
    else{
        cout << "0" << endl;
    }
    return 0;
}