from collections import deque

def najveca_gustina(n, k, a):
    a.sort()
    q = deque()
    max_gustina = 0
    suma = 0
    for i in range(n):
        q.append(a[i])
        suma += a[i]
        if len(q) > k:
            suma -= q.popleft()
        if len(q) == k:
            gustina = suma / (a[i] - q[0])
            max_gustina = max(max_gustina, gustina)
    return max_gustina

n = int(input())
k = int(input())
a = list(map(int, input().split()))

print(f"??????? ??????? ?? {najveca_gustina(n, k, a)}.")