from collections import defaultdict

def organizuj_turnir(k, rezultati):
    pobednici = [[] for _ in range(k)]
    gubitnici = [[] for _ in range(k)]

    for pobednik, gubitnik in rezultati:
        pobednici[0].append(pobednik)
        gubitnici[0].append(gubitnik)

    for i in range(1, k):
        for j in range(len(gubitnici[i - 1])):
            pobednik = pobednici[i - 1][j]
            gubitnik = gubitnici[i - 1][j]
            pobednici[i].append(pobednik if pobednik > gubitnik else gubitnik)
            gubitnici[i].append(gubitnik if pobednik > gubitnik else pobednik)

    return pobednici, gubitnici

def ispisi_rezultate(pobednici, gubitnici):
    print(pobednici[-1][0])
    print(sorted(set(range(2 ** k)) - set(pobednici[-1] + gubitnici[-1]))[0])

    for i in range(k - 1, -1, -1):
        print(*sorted(gubitnici[i]))

k = int(input())
rezultati = [list(map(int, input().split())) for _ in range(2 ** k - 1)]

pobednici, gubitnici = organizuj_turnir(k, rezultati)
ispisi_rezultate(pobednici, gubitnici)