#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>

using namespace std;

bool compare(const pair<int, int>& a, const pair<int, int>& b) {
    return a.second > b.second; // Sortiranje opadajuce po broju ponavljanja
}

int main() {
    int n;
    cin >> n;
    int k = 1;
    for (int i = 0; i < n;++i){
        k *= 2;
    }
    vector<int> pobednici;
    vector<int> gubitnici;
    for (int i = 0; i < k-1;i++){
        for (int j = 0; j < 2;j++){
            int rez;
            cin >> rez;
            if (j == 0){
                pobednici.push_back(rez);
            }
            else{
                gubitnici.push_back(rez);
            }
        }
    }
    unordered_map<int, int> frequency;

    for (int num : pobednici) {
        frequency[num]++;
    }

    vector<pair<int, int>> freqVector(frequency.begin(), frequency.end());

    sort(freqVector.begin(), freqVector.end(), compare);
    int sledeci_broj;
    
    for (size_t i = 0; i < freqVector.size(); ++i){
        int rom = freqVector[i+1].second;
        if(rom == freqVector[i].second){
            cout << freqVector[i].first << " ";
        }
        else{
            cout << freqVector[i].first <<endl;
        }
    }
    for (int i = 0; i < gubitnici.size(); i++){
        int trazeni_br = gubitnici[i];
        auto it = find(pobednici.begin(), pobednici.end(), trazeni_br);
        if (it == pobednici.end()){
            cout << trazeni_br << " ";
        }
    }
    return 0;
}