#include <iostream>
#include <string>

using namespace std;

int calculate_bill(string arr, int k) {
    for (int i = k-1; i < arr.length(); i += k) {
        arr[i] = (arr[i] == '0') ? '1' : '0';
    }
    int count = 0;
    for (int i = 1; i < arr.length(); i++) {
        if (arr[i] != arr[i-1]) {
            count++;
        }
    }
    return count;
}

int main() {
    string s;
    cin >> s;
    int min_bill = s.length();
    int min_k = 1;
    for (int k = 1; k <= s.length(); k++) {
        int bill = calculate_bill(s, k);
        if (bill < min_bill) {
            min_bill = bill;
            min_k = k;
        }
    }
    cout << min_k << " " << min_bill << endl;
    return 0;
}