def moze_formirati_kvadrat(shibice):
    ukupna_duzina = sum(shibice)
    if ukupna_duzina % 4 != 0:
        return 0

    duzina_stranice = ukupna_duzina // 4
    broj_shibica = len(shibice)

    def rekurzivna_funkcija(index, trenutna_duzina):
        if trenutna_duzina == duzina_stranice:
            return 1
        if index == broj_shibica:
            return 0

        # Pokušaj dodavanja trenutne šibice
        rezultat1 = rekurzivna_funkcija(index + 1, trenutna_duzina + shibice[index])

        # Pokušaj preskakanja trenutne šibice
        rezultat2 = rekurzivna_funkcija(index + 1, trenutna_duzina)

        # Ako bar jedna od varijanti uspe, vracamo 1
        return max(rezultat1, rezultat2)

    return rekurzivna_funkcija(0, 0)


# Unos podataka
n = int(input())
duzine_shibica = list(map(int, input().split()))

# Provera da li se može formirati kvadrat
rezultat = moze_formirati_kvadrat(duzine_shibica)

# Ispisivanje rezultata
print(rezultat)