def calculate_density(subset)
    return len(subset) / (max(subset) - min(subset))

def find_subset_with_highest_density(numbers, k):
    subsets = [numbers[i:j] for i in range(len(numbers)) for j in range(i + 1)]
    valid_subsets = [subset for subset in subset if len(subset) == k]

    if not valid_subsets:
        return None

    max_density_subset = max(valid_subsets, key=lambda x: calculate_density(x))
    return sorted(max_density_subset)

numbers = {1, 2, 3, 4, 5, 6, 7, 8, 9}
k = 3
result = find_subset_with_highest_density(numbers, k)

print('Podskup sa najvecom gustinom:', result)