using System;
using System.Collections.Generic;
using System.Linq;

class Program
{
    static void Main()
    {
        int brojIgraca = 8; // Primer za 8 igraca, možete promeniti prema potrebi

        List<Tuple<string, string>> rezultatiMeca = new List<Tuple<string, string>>
        {
            Tuple.Create("Igrac1", "Igrac2"),
            Tuple.Create("Igrac3", "Igrac4"),
            Tuple.Create("Igrac5", "Igrac6"),
            Tuple.Create("Igrac7", "Igrac8"),
        };

        List<string> igraci = Enumerable.Range(1, brojIgraca).Select(i => "Igrac" + i.ToString()).ToList();

        for (int kolo = 1; kolo <= Math.Log2(brojIgraca); kolo++)
        {
            List<string> pobedniciKola = new List<string>();

            foreach (var rezultat in rezultatiMeca)
            {
                if (igraci.Contains(rezultat.Item1) && igraci.Contains(rezultat.Item2))
                {
                    igraci.Remove(rezultat.Item2);
                }
            }
            Console.WriteLine($"Pobednici {kolo}. kola:");
            foreach (var pobednik in pobedniciKola)
            {
                Console.WriteLine(pobednik);
            }
            if (pobedniciKola.Count == 1)
            {
                Console.WriteLine($"Šampion turnira: {pobedniciKola[0]}");
                break;
            }
        }
    }
}