using System;

class Program
{
    static void Main()
    {
        Console.Write("Unesite prirodan broj n: ");
        int n = Convert.ToInt32(Console.ReadLine());

        int m = PronadjiBrojM(n);
        
        Console.WriteLine($"Najmanji prirodan broj m za koji n * m ima neparan broj delilaca je: {m}");
    }

    static int PronadjiBrojM(int n)
    {
        int m = 1;
        while (true)
        {
            int brojDelilaca = BrojDelilaca(n * m);
            if (brojDelilaca % 2 == 1)
            {
                break;
            }

            m++;
        }

        return m;
    }

    static int BrojDelilaca(int broj)
    {
        int brojDelilaca = 0;

        for (int i = 1; i <= broj; i++)
        {
            if (broj % i == 0)
            {
                brojDelilaca++;
            }
        }

        return brojDelilaca;
    }
}