#include <stdio.h>
#include <stdbool.h>

bool mozeKvadrat(int sibice[], int n) {
    int ukupnaDuzina = 0;
    for (int i = 0; i < n; i++) {
        ukupnaDuzina += sibice[i];
    }

    if (ukupnaDuzina % 4 != 0) {
        return false;
    }

    int duzinaStrane = ukupnaDuzina / 4;
    int strane[4] = {0};

    for (int i = 0; i < n - 1; i++) {
        for (int j = i + 1; j < n; j++) {
            if (sibice[i] < sibice[j]) {
                int temp = sibice[i];
                sibice[i] = sibice[j];
                sibice[j] = temp;
            }
        }
    }

    bool dfs(int indeks) {
        if (indeks == n) {
            return strane[0] == duzinaStrane && strane[1] == duzinaStrane && strane[2] == duzinaStrane && strane[3] == duzinaStrane;
        }

        for (int i = 0; i < 4; i++) {
            if (strane[i] + sibice[indeks] <= duzinaStrane) {
                strane[i] += sibice[indeks];
                if (dfs(indeks + 1)) {
                    return true;
                }
                strane[i] -= sibice[indeks];
            }
        }
        return false;
    }

    return dfs(0);
}

int main() {
    int n;
    scanf("%d", &n);
    int sibice[n];
    for (int i = 0; i < n; i++) {
        scanf("%d", &sibice[i]);
    }

    if (mozeKvadrat(sibice, n)) {
        printf("1\n");
    } else {
        printf("0\n");
    }

    return 0;
}