def moze_formirati_kvadrat(sibice):
    # Ako nemamo barem 4 šibice, nije moguce formirati kvadrat
    if len(sibice) < 4:
        return False

    # Ukupna dužina svih šibica
    ukupna_duzina = sum(sibice)

    # Ako ukupna dužina nije deljiva sa 4, nije moguce formirati kvadrat
    if ukupna_duzina % 4 != 0:
        return False

    # Dužina stranice kvadrata
    duzina_stranice = ukupna_duzina // 4

    # Rekurzivna funkcija za proveru
    def proveri_formiranje_kvadrata(sibice, trenutna_stranica, trenutna_duzina):
        if trenutna_stranica == 4:
            return True

        for i in range(len(sibice)):
            if sibice[i] <= trenutna_duzina:
                nova_sibice = sibice[:i] + sibice[i+1:]
                if proveri_formiranje_kvadrata(nova_sibice, trenutna_stranica + 1, duzina_stranice):
                    return True

        return False

    return proveri_formiranje_kvadrata(sibice, 0, duzina_stranice)

# Unos podataka
n = int(input())
sibice = [int(input()) for _ in range(n)]

# Pozivamo funkciju i ispisujemo rezultat
rezultat = moze_formirati_kvadrat(sibice)
print(int(rezultat))