#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Lopta {
    int y;
    double masa;
    int index;
};

bool uporedi(const Lopta &a, const Lopta &b) {
    return 126 / a.masa < 126 / b.masa;
}

int main() {
    int n;
    cin >> n;

    vector<Lopta> lopte(n);
    for (int i = 0; i < n; i++) {
        cin >> lopte[i].y >> lopte[i].masa;
        lopte[i].index = i + 1;
    }

    sort(lopte.begin(), lopte.end(), uporedi);

    for (const auto &lopta : lopte) {
        cout << lopta.index << " ";
    }
    cout << endl;

    return 0;
}