from collections import defaultdict

def odredi_pobednike(k, rezultati):
    pobednici = {i: None for i in range(2**k)}  
    for runda in range(k, 0, -1):
        sledeci = defaultdict(list)
        for pobednik, gubitnik in rezultati:
            if pobednici[gubitnik] is not None: 
                continue

            if pobednici[pobednik] is not None:  
                sledeci[pobednici[pobednik]].append(gubitnik)
            else:  
                sledeci[pobednik].append(gubitnik)

        for pobednik, gubitnici in sledeci.items():
            if len(gubitnici) == 1: 
                pobednici[pobednik] = gubitnici[0]

    return pobednici


k = int(input())
rezultati = [list(map(int, input().split())) for _ in range(2**k - 1)]


pobednici = odredi_pobednike(k, rezultati)


finalisti = []
for i in range(2**k):
    if pobednici[i] is None:
        pobednik = i
    else:
        finalisti.append(i)


print(pobednik)
print(finalisti[0])
for runda in range(k - 1):
    trenutni = []
    for i in range(2**(k - runda - 1)):
        trenutni.append(finalisti.pop(0))
    print(*trenutni)