def minimalni_racun(niz):
    
    broj_nula = [0] * len(niz)
    broj_jedinica = [0] * len(niz)

    for i in range(len(niz)):
        if niz[i] == '0':
            broj_nula[i] = (broj_nula[i - 1] if i > 0 else 0) + 1
            broj_jedinica[i] = broj_jedinica[i - 1] if i > 0 else 0
        else:
            broj_jedinica[i] = (broj_jedinica[i - 1] if i > 0 else 0) + 1
            broj_nula[i] = broj_nula[i - 1] if i > 0 else 0

    najmanji_racun = float('inf')
    k_za_najmanji_racun = 1

    for k in range(1, len(niz) + 1):
        racun = 0
        for i in range(len(niz)):
            if (i + 1) % k == 0:
                if niz[i] == '0':
                    racun += broj_jedinica[i]
                else:
                    racun += broj_nula[i]
        if racun < najmanji_racun:
            najmanji_racun = racun
            k_za_najmanji_racun = k

    return k_za_najmanji_racun, najmanji_racun


niz = input().strip()


rezultat_k, rezultat_racun = minimalni_racun(niz)


print(rezultat_k, rezultat_racun)