import itertools

n = int(input())
lopte = []

for _ in range(n):
    y, masa = map(float, input().split())
    lopte.append((y, masa))

def rastojanje(tacka1, tacka2):
    return ((tacka1[0] - tacka2[0]) ** 2 + (tacka1[1] - tacka2[1]) ** 2) ** 0.5

min_rastojanje = float('inf')
najbolji_redosled = None

permutacije = list(itertools.permutations(range(1, n + 1)))

for redosled in permutacije:
    trenutna_rastojanja = []
    for i in range(n - 1):
        trenutna_rastojanja.append(rastojanje(lopte[redosled[i] - 1], lopte[redosled[i + 1] - 1]))

    ukupna_duzina = sum(trenutna_rastojanja)

    if ukupna_duzina < min_rastojanje:
        min_rastojanje = ukupna_duzina
        najbolji_redosled = redosled

print(*najbolji_redosled)