from collections import deque

R, K = map(int, input().split())
matrica = [input().split() for _ in range(R)]

start = [(i, j) for i in range(R) for j in range(K) if matrica[i][j] == 'S'][0]
cilj = [(i, j) for i in range(R) for j in range(K) if matrica[i][j] == 'C'][0]

def susedi(i, j):
    smerovi = [(0, 1), (1, 0), (0, -1), (-1, 0)]  # Desno, dole, levo, gore
    return [(ni, nj) for ni, nj in [(i + di, j + dj) for di, dj in smerovi] if 0 <= ni < R and 0 <= nj < K and matrica[ni][nj] != 'T']

red = deque([(start, 0)])
posecena = set([start])

while red:
    (i, j), koraci = red.popleft()

    if (i, j) == cilj:
        print(koraci)
        break

    for ni, nj in susedi(i, j):
        if (ni, nj) not in posecena:
            red.append(((ni, nj), koraci + 1))
            posecena.add((ni, nj))