def turnir_poredak(k, rezultati):
    # Mapiranje igraca na trenutni krug takmicenja
    trenutni_krug = {i: i for i in range(2**k)}
    
    # Funkcija koja vraca sledeci krug takmicenja
    def sledeci_krug(pobednici):
        novi_krug = {}
        for i in range(0, len(pobednici), 2):
            igrac1, igrac2 = pobednici[i], pobednici[i + 1]
            novi_krug[igrac1] = novi_krug[igrac2] = min(igrac1, igrac2)
        return novi_krug
    
    # Simulacija takmicenja do finala
    while len(trenutni_krug) > 2:
        pobednici = [rezultati[i][0] for i in trenutni_krug.keys()]
        trenutni_krug = sledeci_krug(pobednici)
    
    # Pronalaženje pobednika i drugoplasiranog u finalu
    finalisti = list(trenutni_krug.keys())
    pobednik_finala = rezultati[finalisti[0]][0] if rezultati[finalisti[0]][1] == finalisti[1] else rezultati[finalisti[1]][0]
    drugoplasirani = rezultati[finalisti[0]][0] if rezultati[finalisti[0]][1] != finalisti[1] else rezultati[finalisti[1]][0]

    # Ispis rezultata
    print(pobednik_finala)
    print(drugoplasirani)
    
    # Ispis ispalica po rundama
    for i i