def turnir_poredak(k, rezultati):
    takmicari = set(range(2**k))
    
    # Pronadi pobednika i drugoplasiranog
    pobednik = rezultati.pop(0)[0]
    drugoplasirani = takmicari.difference({pobednik}).pop()
    
    # Ispali igrace u svakom kolu
    for i in range(k - 1, -1, -1):
        ispali = [igrac for igrac in range(2**k) if igrac not in takmicari and i in rezultati.pop(0)]
        takmicari.difference_update(ispali)
    
    return pobednik, drugoplasirani, sorted(list(takmicari))

# Testiranje
k = int(input())
rezultati = []
for _ in range(2**(k-1)):
    rezultati.append(list(map(int, input().split())))

pobednik, drugoplasirani, ispaljeni = turnir_poredak(k, rezultati)
print(pobednik)
print(drugoplasirani)
for ispaljen in ispaljeni:
    print(ispaljen, end=" ")