#include <iostream>
#include <vector>
using namespace std;

class Tacka
{
public:
	Tacka(int _x, int _y)
	{
		x = _x;
		y = _y;
	}

	int x;
	int y;
};

int main()
{
	int w;
	int h;
	vector<Tacka> portali;

	Tacka start(0, 0);
	Tacka cilj(0, 0);

	cin >> h >> w;

	for (int i = 0; i < h; i++)
	{
		for (int j = 0; j < w; j++)
		{
			char karakter;
			cin >> karakter;

			if (karakter == 'S') 
			{
				start.x = j;
				start.y = i;
			}
			else if (karakter == 'C')
			{
				cilj.x = j;
				cilj.y = i;
			}
			else if (karakter == 'T')
			{
				portali.push_back(Tacka(j, i));
			}
		}
	}

	int udaljenost = abs(start.x - cilj.x) + abs(start.y - cilj.y);

	int najblizeStartu = w + h;
	int najblizeCilju = w + h;

	for (auto portal : portali)
	{
		int tempUdaljenostStart = abs(start.x - portal.x) + abs(start.y - portal.y);
		int tempUdaljenostCilj = abs(cilj.x - portal.x) + abs(cilj.y - portal.y);

		if (najblizeStartu > tempUdaljenostStart) { najblizeStartu = tempUdaljenostStart; }
		if (najblizeCilju > tempUdaljenostCilj) { najblizeCilju = tempUdaljenostCilj; }
	}

	if (udaljenost < najblizeStartu + najblizeCilju) { cout << udaljenost; }
	else { cout << najblizeStartu + najblizeCilju; }
}