def smallest_bill(usage):
    n = len(usage)
    number_of_ones = usage.count('1')
    
    best_k = 1
    min_bill = number_of_ones

    ones_so_far = 0
    zeros_so_far = 0

    for i in range(n):
        if usage[i] == '1':
            ones_so_far += 1
        else:
            zeros_so_far += 1

        changes = ones_so_far + (number_of_ones - ones_so_far) + zeros_so_far - 1
        if changes < min_bill:
            min_bill = changes
            best_k = i + 1

    print(min_bill, best_k)

usage = input().strip()

smallest_bill(usage)