def count_divisors(n):
    divisors = 0
    i = 1
    
    while i * i <= n:
        if n % i == 0:
            divisors += 2  
            if i * i == n:
                divisors -= 1 
        i += 1
    
    return divisors

def find_m(n):
    divisors = count_divisors(n)
    
    if divisors % 2 == 1:
        return 1

    i = 2
    while True:
        if count_divisors(n * i) % 2 == 1:
            return i
        i += 1

n = int(input())

result = find_m(n)
print(result)