#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct ball{
    double x;
    double y;
    int num;

};
const double INF=numeric_limits<double>::max();

bool cmp(const ball& A, const ball & B){
    if(A.x<B.y)return true;
    return false;
}

void dis(vector<int>& ans,vector<int>& raspored ,int l, int r, vector<bool>& vis,vector<ball>& v, int pb,int i,int n, double& mindis){
    raspored[i]=pb;
    if(i==n-1){
        double dis=0;
        for(int i=1;i<raspored.size();i++){
            dis+=sqrt(abs(v[raspored[i]].x-v[raspored[i-1]].x)*abs(v[raspored[i]].x-v[raspored[i-1]].x) +abs(v[raspored[i]].y-v[raspored[i-1]].y)*abs(v[raspored[i]].y-v[raspored[i-1]].y));
        }
        if(dis<mindis){
            for(int i=0;i<raspored.size();i++)ans[i]=raspored[i];
            mindis=dis;
        }
    }
    vis[pb]=true;
    for(int j=l;j<=r;j++){
        if(!vis[j])
            dis(ans,raspored,l,r,vis,v, j, i+1,n,mindis);
    }
    vis[pb]=false;

}


int main()
{
    int n;
    cin>>n;
    vector<ball> v(n);
    for(int i=0;i<n;i++){
        double x,y;
        cin>>x>>y;
        v[i].x=(double)126/y;
        v[i].y=x;
        v[i].num=i;
    }
    sort(v.begin(),v.end(),cmp);
    int granica;
    for(int i=0;i<n;i++){
        if(v[i].x>0){
            granica=i;
            break;
        }
    }

    vector<bool> vis(n,false);
    vector<vector<int>> neg(granica);
    vector<double> dneg(granica);
    vector<int> raspored;
    for(int i=0;i<granica;i++){
        neg[i].resize(granica);
        raspored.resize(granica);
        double mindis=INF;
        vis.assign(n,false);
        dis(neg[i],raspored, 0,granica-1,vis,v,i,0,granica,mindis);
        dneg[i]=mindis;
    }
    vector<vector<int>> poz(n-granica);
    vector<double> dpoz(n-granica);
    for(int i=0;i<n-granica;i++){
        poz[i].resize(n-granica);
        raspored.resize(n-granica);
        double mindis=INF;
        vis.assign(n,false);
        dis(poz[i],raspored, granica,n-1,vis,v,i+granica,0,n-granica,mindis);
        dpoz[i]=mindis;
    }

    int r,k;
    double d=INF;
    for(int i=0;i<granica;i++){
        for(int j=0;j<n-granica;j++){
            if(dneg[i]+dpoz[j]+sqrt(abs(v[i].x-v[granica+j].x)*abs(v[i].x-v[granica+j].x) + abs(v[i].y-v[granica+j].y)*abs(v[i].y-v[granica+j].y))<d){
                r=i;
                k=j;
                d=dneg[i]+dpoz[j]+sqrt(abs(v[i].x-v[granica+j].x)*abs(v[i].x-v[granica+j].x) + abs(v[i].y-v[granica+j].y)*abs(v[i].y-v[granica+j].y));
            }
        }
    }
    for(int i=granica-1;i>=0;i--){
        cout<<v[neg[r][i]].num+1<<' ';
    }
    for(int i=0;i<n-granica;i++){
        cout<<v[poz[k][i]].num+1<<' ';
    }



    return 0;
}