import itertools


def udaljenost(lopta1, lopta2):
    return ((lopta1[0] - lopta2[0]) ** 2 + (lopta1[1] - lopta2[1]) ** 2) ** 0.5


def ukupna_udaljenost(redosled, lopte):
    distanca = 0
    for i in range(len(redosled) - 1):
        distanca += udaljenost(lopte[redosled[i]], lopte[redosled[i + 1]])
    return distanca


def najkraca_udaljenost(redosled, lopte):
    najkraca_distanca = float("inf")
    najbolji_redosled = None
    sve_kombinacije = kombinacije(redosled)
    for komb in sve_kombinacije:
        if komb == (0, 1, 2, 5, 3, 4):
            a = 2
        if komb == (0, 1, 2, 3, 5, 4):
            a = 2

        distanca = ukupna_udaljenost(komb, lopte)
        if distanca < najkraca_distanca:
            najkraca_distanca = distanca
            najbolji_redosled = komb
    return najbolji_redosled


def kombinacije(arr):
    kombi = itertools.permutations(arr, len(arr))

    return kombi


n = int(input())
lopte = []
lopte2 = []
allys0 = True
for i in range(n):
    l1 = input().split()
    lopte.append([126 / float(l1[1]), float(l1[0])])
    lopte2.append([126 / float(l1[1]), float(l1[0]), i])

    if float(l1[0]) != 0.0:
        allys0 = False

if allys0 == True:
    lopte2.sort()
    for i in range(n):
        print(lopte2[i][2] + 1)
    exit()

pocetni_redosled = []
for i in range(n):
    pocetni_redosled.append(i)

najbolji_redosled = najkraca_udaljenost(pocetni_redosled, lopte)
res = ""
for item in najbolji_redosled:
    res += str(item + 1) + " "
print(res)