#include <iostream>
#include <vector>

int main() {
    std::string potrosnja;
    std::cin >> potrosnja;

    int n = potrosnja.size();
    int brojPromena = 0;
  
    for (int i = 1; i < n; ++i) {
        if (potrosnja[i] != potrosnja[i - 1]) {
            brojPromena++;
        }
    }
    int optimalno_k = 1;
    int minimalniRacun = brojPromena;

    for (int k = 2; k <= n; ++k) {
        int promeneUKoraku = 0;

        for (int i = k - 1; i < n; i += k) {
            if (potrosnja[i] != potrosnja[i - 1]) {
                promeneUKoraku++;
            }
        }

        if (promeneUKoraku < minimalniRacun) {
            minimalniRacun = promeneUKoraku;
            optimalno_k = k;
        }
    }

    std::cout << optimalno_k << " " << minimalniRacun << std::endl;

    return 0;
}