#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

struct Lopta {
    int indeks;
    double yKoord;
    double masa;
};

bool uporediLopte(const Lopta& lopta1, const Lopta& lopta2) {
    
    return (126.0 / lopta1.masa) < (126.0 / lopta2.masa);
}

int main() {
    int n;
    std::cin >> n;

    std::vector<Lopta> lopte;
    lopte.reserve(n);

    for (int i = 0; i < n; ++i) {
        double y, masa;
        std::cin >> y >> masa;
        lopte.push_back({i + 1, y, masa});
    }

   
    std::sort(lopte.begin(), lopte.end(), uporediLopte);


    for (const Lopta& lopta : lopte) {
        std::cout << lopta.indeks << " ";
    }

    return 0;
}