def najmanji_racun(potrosnja):
    n = len(potrosnja)

    # Broj promena sa 0 na 1 ili obrnuto
    broj_promena = [0] * (n + 1)
    for i in range(1, n + 1):
        broj_promena[i] = broj_promena[i - 1] + (potrosnja[i - 1] == '1')

    najmanji_racun = float('inf')
    najbolji_k = 0

    for k in range(1, n + 1):
        promene_0_na_1 = broj_promena[k]  # Promene sa 0 na 1
        promene_1_na_0 = broj_promena[n] - broj_promena[k]  # Promene sa 1 na 0

        trenutni_racun = promene_0_na_1 + promene_1_na_0

        if trenutni_racun < najmanji_racun:
            najmanji_racun = trenutni_racun
            najbolji_k = k

    return najbolji_k, najmanji_racun

# Citanje ulaznih podataka
potrosnja = input()

# Pozivanje funkcije i ispis rezultata
rezultat_k, rezultat_racun = najmanji_racun(potrosnja)
print(rezultat_k, rezultat_racun)