using System;

public class Program
{
    public static void Main()
    {
        int[] mase = new int[4];

        for (int i = 0; i < 4; i++)
        {
            Console.Write("Unesite masu {i + 1}. daka: ");
            string input = Console.ReadLine();

            // Handling null or empty input
            if (string.IsNullOrEmpty(input))
            {
                Console.WriteLine("Invalid input. Please enter a valid integer.");
                return;
            }

            // Parsing the input to integers
            if (!int.TryParse(input, out mase[i]))
            {
                Console.WriteLine("Invalid input. Please enter a valid integer.");
                return;
            }
        }

        // Calculate sums of masses on both sides
        int zbirLevaStrana = mase[0] + mase[1];
        int zbirDesnaStrana = mase[2] + mase[3];

        // Check if balance can be achieved
        if (zbirLevaStrana == zbirDesnaStrana)
        {
            Console.WriteLine("da");

            // Calculate the minimum number of bags
            int razlika = Math.Abs(zbirLevaStrana - zbirDesnaStrana);
            int brojTorbi = (razlika + 1) / 2;
            Console.WriteLine(brojTorbi);
        }
        else
        {
            Console.WriteLine("ne");
        }
    }
}