#include <iostream>

using namespace std;
int zaneg;
int zapoz;
const int maxn = 20;
string res = "";
typedef struct {
    double d;
    double s;
    int perm[maxn];
} ms_t;
typedef struct {
    double x;
    double y;
    int redni;
} ms_t2;
double razdaljina(double x1, double y1, double x2, double y2){
    return ((x1 - x2)*(x1 - x2)) + ((y1 - y2)*(y1 - y2));
}




int r(int i, int cnt, int  maxi, int permutacija[maxn], bool visited[maxn],  ms_t povez[maxn][maxn]){
    permutacija[cnt]=i;
    visited[i] = true;

    //da li sam dosao do kraja permutacije
    if(cnt >= (maxi-1)){
        double suma = 0;
        for(int ii = 0; ii < maxi-1; ii++) {
            //permaticija[ii]
            suma+=povez[permutacija[ii]][permutacija[ii+1]].d;
        }
        int s = permutacija[0];
        int e = permutacija[maxi-1];
        if (suma < povez[s][e].s){
            povez[s][e].s = suma;
            povez[e][s].s = suma;
            for(int ii = 0; ii < maxi; ii++) {
                povez[s][e].perm[ii] = permutacija[ii];
                povez[e][s].perm[maxi-1-ii] = permutacija[ii];
            }
        }

        return 0;
    }

    for(int ii = 0; ii < maxi; ii++)
        if(!visited[ii]) {
            r(ii, cnt+1, maxi, permutacija,visited,povez);
            visited[ii]= false;
        }
}





int main()
{
    const double A = 126.0;
    int n;
    cin >> n;
    ms_t2 neg[maxn]; zaneg = 0;
    ms_t2 poz[maxn]; zapoz = 0;
    double unosY, unosMASA;
    for(int i = 0; i < n; i++) {
        cin >> unosY;
        cin >> unosMASA;
        if(unosMASA < 0){
            neg[zaneg].y = unosY;
            neg[zaneg].x = A/unosMASA;
            neg[zaneg].redni = i+1;
            zaneg++;
        }
        else {
            poz[zapoz].y = unosY;
            poz[zapoz].x = A/unosMASA;
            poz[zapoz].redni = i+1;
            zapoz++;
        }
    }
    ms_t negpovez[maxn][maxn];
    ms_t pozpovez[maxn][maxn];
    for(int i = 0; i < zaneg; i++)
        for(int j = 0; j < zaneg; j++){
            negpovez[i][j].d = razdaljina(neg[i].x, neg[i].y , neg[j].x, neg[j].y);
            negpovez[j][i].s  = negpovez[i][j].s = INT_MAX;
         }
    for(int i = 0; i < zapoz; i++)
        for(int j = 0; j < zapoz; j++){
           pozpovez[i][j].d = razdaljina(poz[i].x, poz[i].y , poz[j].x, poz[j].y);
           pozpovez[j][i].s = pozpovez[i][j].s = INT_MAX;
         }


    bool visited[zaneg];
    int permutacija[zaneg];
    int suma=0;
    for(int i = 0; i < zaneg; i++) visited[i] = false;
    for(int i = 0; i < zaneg; i++){
        r(i,0,zaneg,permutacija,visited, negpovez);
    }

    bool visited2[zapoz];
    int permutacija2[zapoz];
    suma=0;
    for(int i = 0; i < zapoz; i++) visited2[i] = false;
    for(int i = 0; i < zapoz; i++){
        r(i,0,zapoz,permutacija2,visited2, pozpovez);
    }

    //conquer
    double res_suma = INT_MAX;
    int res_perm[n];
    for(int i = 0; i < zaneg; i++)
        for(int j = 0; j < zaneg; j++)
            for(int p = 0; p < zapoz; p++)
                for(int k = 0; k < zapoz; k++){
                        //sracunaj povezanu sumu
                        double suma = negpovez[i][j].s + pozpovez[p][k].s;
                        suma += razdaljina(neg[j].x, neg[j].y , neg[p].x, neg[p].y);

                        //ako je najmanja
                        if (suma < res_suma) {
                            res_suma = suma;
                            //kopiraj permutaciju
                            int idx = 0;
                            for(int ii = 0; ii < zaneg; ii++) {
                                int r = negpovez[i][j].perm[ii];
                                res_perm[idx++] = neg[r].redni;
                            }

                            for(int ii = 0; ii < zapoz; ii++) {
                                int r = pozpovez[p][k].perm[ii];
                                res_perm[idx++] = poz[r].redni;
                            }
                        }

                }

    //printf("P[%f]: ", res_suma);
    for(int i = 0; i < n; i++) printf("%d ", res_perm[i]);
    printf("\n");

    return 0;
}