def smallest_m_with_odd_divisors(n):
    # ???????? ??????? ??????? ? ??????? ??????????? ? ??????? ????? n
    prime_factors = {}
    i = 2
    while i * i <= n:
        while n % i == 0:
            prime_factors[i] = prime_factors.get(i, 0) + 1
            n //= i
        i += 1
    if n > 1:
        prime_factors[n] = prime_factors.get(n, 0) + 1
    
    # ???????????? ???????? ????? m ?????? ?? n * m ??? ??????? ???? ????????
    result = 1
    for factor, exponent in prime_factors.items():
        # ?? ????? ????? ????, ??? ??? ????????? 1, ?????? ?? ???????
        if exponent == 1:
            result *= factor
        # ??? ??? ????????? ???? ?? 1, ?????? ?? ??????? ?? ????? ????
        elif exponent % 2 == 1:
            result *= factor ** (exponent + 1)

    return result

# ????????? ??????? ????????
n = int(input())

# ?????????? ?????????
print(smallest_m_with_odd_divisors(n))