def moze_formirati_kvadrat(palidrvaca):
    ukupna_duzina = sum(palidrvaca)
    if ukupna_duzina % 4 != 0:
        return 0

    ciljna_duzina_stranice = ukupna_duzina // 4

    def backtrack(indeks, stranice):
        if indeks == len(palidrvaca):
            return all(stranica == ciljna_duzina_stranice for stranica in stranice)

        trenutno_palidrvace = palidrvaca[indeks]

        for i in range(4):
            if stranice[i] + trenutno_palidrvace <= ciljna_duzina_stranice:
                stranice[i] += trenutno_palidrvace
                if backtrack(indeks + 1, stranice):
                    return 1
                stranice[i] -= trenutno_palidrvace

        return 0

    return backtrack(0, [0, 0, 0, 0])

# Ucitavanje ulaza
n = int(input())
palidrvaca = list(map(int, input().split()))

# Provera i ispis rezultata
rezultat = moze_formirati_kvadrat(palidrvaca)
print(rezultat)