#include <iostream>
#include <vector>
#include <queue>

struct Igrac {
    int id;
    int eliminisanoKolo; 
};

int main() {
    int k;
    std::cin >> k;

    int brojIgraca = 1 << k; 
    std::vector<Igrac> igraci(brojIgraca);

    for (int i = 0; i < brojIgraca; ++i) {
        igraci[i].id = i;
    }

    
    for (int i = 0; i < brojIgraca - 1; ++i) {
        int pobednik, gubitnik;
        std::cin >> pobednik >> gubitnik;
        
       
        igraci[gubitnik].eliminisanoKolo = i + 1;
    }

    
    std::priority_queue<int, std::vector<int>, std::greater<int>> prioritetniRed;

    for (const auto& igrac : igraci) {
        prioritetniRed.push(igrac.eliminisanoKolo);
    }

    std::cout << prioritetniRed.top() << std::endl; 
    prioritetniRed.pop();
    std::cout << prioritetniRed.top() << std::endl; 

    
    for (int i = 2; i <= k; ++i) {
        int igraciUkolima = 1 << (k - i);
        for (int j = 0; j < igraciUkolima; ++j) {
            std::cout << prioritetniRed.top() << " ";
            prioritetniRed.pop();
        }
        std::cout << std::endl;
    }

    return 0;
}