#include <iostream>
#include <vector>
#include <algorithm>

bool canFormSquare(const std::vector<int>& sibice) {
    

    // Sortiranje dužina šibica od najvece ka najmanjoj
    std::vector<int> sortedSibice(sibice);
    std::sort(sortedSibice.rbegin(), sortedSibice.rend());

    
    if (sortedSibice.size() < 4) {
        return false;
    }

    
    int sideLength = sortedSibice[0] + sortedSibice[1] + sortedSibice[2] + sortedSibice[3];

    
    for (int i = 0; i < 4; ++i) {
        if (sideLength - sortedSibice[i] > 0) {
            sideLength -= sortedSibice[i];
        } else {
            return false;
        }
    }

    return (sideLength == 0);
}

int main() {
    int n;
    std::cin >> n;

    std::vector<int>sibice(n);
    for (int i = 0; i < n; ++i) {
        std::cin >>sibice[i];
    }

    
    if (canFormSquare(sibice)) {
        std::cout << "1\n";
    } else {
        std::cout << "0\n";
    }

    return 0;
}