from collections import deque
def najmanji_broj_koraka(matrica):
    R, K = len(matrica), len(matrica[0])
    start, cilj, teleporti = None, None, {}
    for i in range(R):
        for j in range(K):
            if matrica[i][j] == 'S':
                start = (i, j)
            elif matrica[i][j] == 'C':
                cilj = (i, j)
            elif matrica[i][j] == 'T':
                teleporti[(i, j)] = True
    def validna_pozicija(x, y):
        return 0 <= x < R and 0 <= y < K and matrica[x][y] != 'T'
    red = deque([(start[0], start[1], 0)])
    poseceno = set([(start[0], start[1])])
    broj_koraka = 0
    while red:
        x, y, broj_koraka = red.popleft()
        if (x, y) == cilj:
            break
        potezi = [(x + 1, y), (x - 1, y), (x, y + 1), (x, y - 1)]
        for teleport, aktivan in teleporti.items():
            if aktivan and teleport != (x, y):
                potezi.append(teleport)?
        for p in potezi:
            if validna_pozicija(p[0], p[1]) and p not in poseceno:
                red.append((p[0], p[1], broj_koraka + 1))
                poseceno.add((p[0], p[1]))
    return broj_koraka
R, K = map(int, input().split())
matrica = [input().split() for _ in range(R)]
rezultat = najmanji_broj_koraka(matrica)
print(rezultat)