def broj_petrova(n, sedista):
    # Sortiraj sedišta u opadajucem redosledu
    sedista.sort(reverse=True)

    # Inicijalizuj broj parova
    broj_parova = 0

    # Brojimo parove
    for i in range(n):
        broj_parova += sedista[i] // 2
        sedista[i] %= 2

    # Proveravamo ima li još sedišta koja se mogu koristiti
    for i in range(n - 1):
        if sedista[i] == 1 and sedista[i + 1] == 1:
            broj_parova += 1
            sedista[i] = 0
            sedista[i + 1] = 0

    return broj_parova

# Ucitavanje ulaza
n = int(input())
sedista = [int(input()) for _ in range(n)]

# Poziv funkcije i ispis rezultata
rezultat = broj_petrova(n, sedista)
print(rezultat)