def min_cost_and_k(internet_usage):
    n = len(internet_usage)
    cost = float('inf')
    best_k = 1

    # Provera za sve vrednosti k od 1 do n
    for k in range(1, n + 1):
        current_cost = 0
        current_internet_usage = list(internet_usage)  # Kopiranje niza

        # Menjanje svakog k-tog elementa
        for i in range(k - 1, n, k):
            current_internet_usage[i] = '1' if current_internet_usage[i] == '0' else '0'

        # Racunanje troška za trenutnu vrednost k
        for i in range(n - 1):
            if current_internet_usage[i] != current_internet_usage[i + 1]:
                current_cost += 1

        # Ažuriranje najmanjeg troška
        if current_cost < cost:
            cost = current_cost
            best_k = k

    return best_k, cost

# Ucitavanje ulaza
internet_usage = input().strip()

# Poziv funkcije i ispis rezultata
result = min_cost_and_k(internet_usage)
print(result[0], result[1])