def najmanji_broj_sa_neparnim_deliocima(n):
    # Funkcija koja odreduje najmanji broj m takav da n * m ima neparan broj delilaca
    
    # Pomocna funkcija za racunanje broja delilaca
    def broj_delilaca(x):
        count = 0
        for i in range(1, int(x**0.5) + 1):
            if x % i == 0:
                count += 2  # Par delilaca (i i x/i)
                if i == x/i:
                    count -= 1  # Popravka za savršene kvadrate
        return count
    
    m = 1
    while broj_delilaca(n * m) % 2 == 0:
        m += 1
    
    return m

# Ucitavanje ulaza
n = int(input())

# Poziv funkcije i ispis rezultata
rezultat = najmanji_broj_sa_neparnim_deliocima(n)
print(rezultat)