def dist(a: list[int], b: list[int]):
    c = []
    for i in range(len(a)):
        c.append(abs(a[i]-b[i]))
    return sum(c)

height, width = (int(x) for x in input().split())
matrix = [[x for x in input().split()] for y in range(height)]
start = []
gates = []
end = []
for i, row in enumerate(matrix):
    for j, cell in enumerate(row):
        if cell.upper() == 'S':
            start = [i, j]
        elif cell.upper() == 'T':
            gates.append([i, j])
        elif cell.upper() == "C":
            end = [i, j]

min_dist = dist(start, end)
for gate1 in gates:
    for gate2 in gates:
        if gate1 == gate2:
            continue
        min_dist = min(min_dist, dist(start, gate1)+dist(gate2, end))

print(min_dist)