#include<bits/stdc++.h>
using namespace std;

int n;
vector<pair<double, double>> lopte;
vector<int> najboljiPerm;

double rastojanje(const vector<int>& order) {
    double totalDistance = 0.0;

    for (int i = 1 ; i < order.size() ; i++) {
        totalDistance += sqrt(pow(abs(lopte[order[i]].first - lopte[order[i-1]].first), 2) + pow(lopte[order[i]].second-lopte[order[i-1]].second, 2));
    }

    return totalDistance;
}

void findnajboljiPerm() {
    vector<int> currPerm(n);
    for (int i = 0; i < n; i++) {
        currPerm[i]=i;
    }

    double minDistance = numeric_limits<double>::infinity();

    do {
        double currentDistance = rastojanje(currPerm);
        if (currentDistance < minDistance) {
            minDistance = currentDistance;
            najboljiPerm = currPerm;
        }
    } while (next_permutation(currPerm.begin(), currPerm.end()));
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    lopte.resize(n);

    for (int i = 0; i < n; i++) {
        cin >> lopte[i].second >> lopte[i].first;
        lopte[i].first = 126 / lopte[i].first; 
    }
    findnajboljiPerm();

    for (int i : najboljiPerm) {
        cout << i +1 << " ";
    }

    return 0;
}
//brute force vrv moze bolje sa meet in the middle ali cvrc