def moze_formirati_kvadrat(sibice):
    uk_duz = sum(sibice)
    duz_stranice = uk_duz // 4 
    if uk_duz % 4 != 0 or max(sibice) > duz_stranice:
        return False
    stranice = [0] * 4
  
    sibice.sort(reverse=True)

    def povratak_unazad(indeks):
        if indeks == len(sibice):
            return all(strana == duz_stranice for strana in stranice)

        for i in range(4):
            if stranice[i] + sibice[indeks] <= duz_stranice:
                stranice[i] += sibice[indeks]
                if povratak_unazad(indeks + 1):
                    return True
                stranice[i] -= sibice[indeks]
        return False

    return povratak_unazad(0)

br_sibica = int(input("Unesite broj sibica: "))

duz_sibica = []
for i in range(br_sibica):
    duz = int(input(f"Unesite dužinu šibice {i + 1}: "))
    duz_sibica.append(duz)

moze_formirati_kvadrat_rezultat = moze_formirati_kvadrat(duz_sibica)
print(f"Da li možete formirati kvadrat: {moze_formirati_kvadrat_rezultat}")