from heapq import heapify, heppush, heppop

def najgustiji_podskup(n, k, a):
    a.sort()


    min_heap = [(a[i + 1] - a[i], i) for i in range (n - 1)]
    heapify(min_heap)


    podskup = set(range(k - 1))


    while True:
        _, index = heappop(min_heap)
        podskup.add(index + k)

        if len(podskup) == k:
            break


    for index in sorted(podskup):
        print(a[index], end = " ")


n = int(input())
k = int(input())
a = list(map(int, input().split()))


if 1 <= n <= 2 * 10**5 and 1 <= k <= n:
    najgustiji_podskup(n, k, a)
else:
    print("Neispravan iznos")