broj_lopti = int(input())
lopte = [tuple(map(float, input().split())) for _ in range(broj_lopti)]

def izracunaj_udaljenost(koord1, koord2):
    return abs(koord1[0] - koord2[0]) + abs(koord1[1] - koord2[1])

def ukupna_udaljenost_redosleda(redosled, lopte):
    udaljenost = 0
    trenutna_pozicija = (0, 0)

    for indeks_lopte in redosled:
        koordinate_lopte = lopte[indeks_lopte - 1][0]
        udaljenost += izracunaj_udaljenost(trenutna_pozicija, koordinate_lopte)
        trenutna_pozicija = koordinate_lopte

    return udaljenost

def pronadji_redosled_min_udaljenosti(broj_lopti, lopte):
    indeksi_lopti = list(range(1, broj_lopti + 1))
    min_udaljenost = float('inf')
    redosled_min_udaljenosti = None

    for redosled in permutations(indeksi_lopti):
        udaljenost = ukupna_udaljenost_redosleda(redosled, lopte)
        if udaljenost < min_udaljenost:
            min_udaljenost = udaljenost
            redosled_min_udaljenosti = redosled

    return redosled_min_udaljenosti

redosled_min_udaljenosti = pronadji_redosled_min_udaljenosti(broj_lopti, lopte)
print(" ".join(map(str, redosled_min_udaljenosti)))