def min_do_cilja(m):
    red, kol = len(m), len(m[0])
    stran= [(0, 1), (0, -1), (1, 0), (-1, 0)]

    def tac(x, y):
        return 0 <= x < red and 0 <= y < kol and m[x][y] != 'T'

    pocetna = [(i, j) for i in range(red) for j in range(kol) if m[i][j] == 'S'][0]
    pose = set([(pocetna, 0)])
    r = [(pocetna, 0)]

    while r:
        tren, koraci = r.pop(0)

        x, y = tren
        for dx, dy in stran:
            n_x, n_y = x + dx, y + dy

            if tac(n_x, n_y) and (n_x, n_y) not in pose:
                if m[n_x][n_y] == 'C':
                    return koraci + 1

                r.append(((n_x, n_y), koraci + 1))
                pose.add((n_x, n_y))

    return -1  


R, K = map(int, input().split())
m = [input().split() for _ in range(R)]
rez = min_do_cilja(m)
print(rez)