from itertools import combinations

def najgusta_podskup(n, k, skup):
    max_gustina = 0
    najmanji_elementi = ()

    for podskup in combinations(skup, k):
        min_element = min(podskup)
        max_element = max(podskup)
        gustina = len(podskup) / (max_element - min_element)

        if gustina > max_gustina or (gustina == max_gustina and podskup < najmanji_elementi):
            max_gustina = gustina
            najmanji_elementi = podskup

    return najmanji_elementi

n, k = map(int, input().split())
skup = list(map(int, input().split()))

rezultat = najgusta_podskup(n, k, skup)

print(" ".join(map(str, sorted(rezultat))))