#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    int k;
       std::cin >> k;

    std::vector<std::pair<int, int>> pairs;

 
    for (int i = 0; i < k; ++i) {
        int first, second;
        std::cout << i + 1 << ": ";
        std::cin >> first >> second;
        pairs.push_back(std::make_pair(first, second));
    }

       std::sort(pairs.begin(), pairs.end(), [](const auto& a, const auto& b) {
        return a.first + a.second > b.first + b.second;
    });

      for (const auto& pair : pairs) {
        std::cout << pair.first << " " << pair.second << "\n";
    }

    return 0;
}