import random

def generisi_raspored_takmicara(broj_takmicara, broj_rundi):
    takmicari = list(range(1, broj_takmicara + 1))
    raspored = []
    
    for runda in range(1, broj_rundi + 1):
        random.shuffle(takmicari)
        parovi = []
        
        for i in range(0, len(takmicari), 2):
            domacin = takmicari[i]
            gost = takmicari[i + 1]
            parovi.append((domacin, gost))
        
        raspored.append(parovi)
    
    return raspored

broj_takmicara = int(input("Unesite broj takmicara: "))
broj_rundi = int(input("Unesite broj rundi: "))

raspored_takmicara = generisi_raspored_takmicara(broj_takmicara, broj_rundi)

for runda, parovi in enumerate(raspored_takmicara, start=1):
    print(f"Runda {runda}:")
    
    for domacin, gost in parovi:
        print(f"Par {domacin} vs {gost}")