def cal_min_bill(s):
    n = len(s)
    current_bill = s.count('1')  
    best_k = 1  
    best_bill = current_bill

    for k in range(1, n + 1):
        # Calculate the bill for the current k
        new_bill = current_bill + (s[k - 1] == '0') - (s[k - 1] == '1')
        if new_bill < best_bill:
            best_k = k
            best_bill = new_bill

        current_bill = new_bill

    return best_k, best_bill
internet_usage = input().strip()
r_k, r_bill = cal_min_bill(internet_usage)
print(r_k, r_bill)