import math

def calculate_distance(x1, y1, x2, y2):
    return math.sqrt((x1 - x2)**2 + (y1 - y2)**2)

def izbaci_loptu(lopte, index):
    for i in range(len(lopte)):
        if lopte[i][2] == index:
            lopte.pop(i)
            break

n = int(input()) # broj lopti

lopte = list()

pokupljene = list()

snaga = 126

for i in range(n):
    red = list(map(float, input().split())) 
    lopte.append((snaga / red[1], red[0], i + 1))

start_index    = -1
max_distanca = -math.inf

tekuce_x = -1.
tekuce_y = -1.

sledeci_index = -1
sledece_x = -1.
slecece_y = -1.

for lopta in lopte:
    distanca = calculate_distance(lopta[0], lopta[1], 0., 0.)
    if distanca > max_distanca:
        tekuce_x = lopta[0]
        tekuce_y = lopta[1]
        start_index  = lopta[2]
        max_distanca = distanca

pokupljene.append(start_index)
izbaci_loptu(lopte, start_index)

while len(lopte) > 0:
    min_distanca = math.inf
    for lopta in lopte:
        distanca = calculate_distance(tekuce_x, tekuce_y, lopta[0], lopta[1])
        if distanca < min_distanca:
            sledece_x = lopta[0]
            sledece_y = lopta[1]
            sledeci_index = lopta[2]
            min_distanca = distanca

    pokupljene.append(sledeci_index)
    izbaci_loptu(lopte, sledeci_index)

    tekuce_x = sledece_x
    tekuce_y = sledece_y

for i in range(len(pokupljene)):
    if i == len(pokupljene) - 1:
        print(pokupljene[i], end='')
    else:
        print(pokupljene[i], end=' ')