def find_subset_with_max_density(n, k, a):
    a.sort()  

    max_density = 0
    selected_subset = []

    for i in range(n - k + 1):
        subset = a[i:i + k]
        subset_density = len(subset) / (subset[-1] - subset[0])

        if subset_density > max_density or (subset_density == max_density and subset < selected_subset):
            max_density = subset_density
            selected_subset = subset

    return selected_subset



n, k = map(int, input().split())
a = list(map(int, input().split()))


result = find_subset_with_max_density(n, k, a)
print(" ".join(map(str, result)))