from collections import deque

def najmanji_broj_koraka(matrica):
    start = None
    cilj = None

    for i in range(len(matrica)):
        for j in range(len(matrica[i])):
            if matrica[i][j] == 'S':
                start = (i, j)
            elif matrica[i][j] == 'C':
                cilj = (i, j)

    red = start[0]
    kolona = start[1]

    posete = set()
    posete.add((red, kolona))

    redovi_kolone = [(red, kolona, 0)]

    while redovi_kolone:
        trenutni_red, trenutna_kolona, broj_koraka = redovi_kolone.pop(0)

        if (trenutni_red, trenutna_kolona) == cilj:
            return broj_koraka

        smerovi = [(1, 0), (-1, 0), (0, 1), (0, -1)]

        for smer in smerovi:
            novi_red = trenutni_red + smer[0]
            nova_kolona = trenutna_kolona + smer[1]

            if 0 <= novi_red < len(matrica) and 0 <= nova_kolona < len(matrica[0]) and matrica[novi_red][nova_kolona] != 'T' and (novi_red, nova_kolona) not in posete:
                posete.add((novi_red, nova_kolona))
                redovi_kolone.append((novi_red, nova_kolona, brojkoraka + 1))

    return -1 

R, K = map(int, input().split())
matrica = [input().split() for  in range(R)]

rezultat = najmanji_broj_koraka(matrica)
print(rezultat)