def najmanji_broj_sa_neparnim_deliocima(n):
    def je_prost(broj):
        if broj < 2:
            return False
        for i in range(2, int(broj**0.5) + 1):
            if broj % i == 0:
                return False
        return True

    def broj_delilaca(broj):
        count = 0
        for i in range(1, broj + 1):
            if broj % i == 0:
                count += 1
        return count

    if je_prost(n):
        return 1

    m = 2
    while True:
        if broj_delilaca(n * m) % 2 == 1:
            return m
        m += 1

n = int(input())
print(najmanji_broj_sa_neparnim_deliocima(n))