def find_subset_with_max_density(numbers, k):
    numbers.sort()
    max_density = 0
    result_subset = []

    for i in range(len(numbers) - k + 1):
        subset = numbers[i:i + k]
        density = len(subset) / (subset[-1] - subset[0])

        if density > max_density or (density == max_density and subset < result_subset):
            max_density = density
            result_subset = subset

    return result_subset


# Ucitavanje ulaza
n, k = map(int, input().split())
numbers = list(map(int, input().split()))

# Pronalaženje i ispis rezultata
result = find_subset_with_max_density(numbers, k)
print(*result)