def simuliraj_rezultate_turnira(k, rezultati):
    igraci = list(range(2 ** k))
    eliminisani = set()

    def sledeci_krug(igraci):
        return [(igraci[i], igraci[i + 1]) for i in range(0, len(igraci), 2)]

    output = []

    for pobednik, gubitnik in rezultati:
        eliminisani.add(gubitnik)

    pobednik = next((igrac for igrac in igraci if igrac not in eliminisani), None)
    eliminisani.add(pobednik)
    drugoplasirani = next((igrac for igrac in igraci if igrac not in eliminisani), None)

    preostali_igraci = sledeci_krug(igraci)

    for i in range(k - 1):
        trenutni_krug = sledeci_krug(preostali_igraci)
        eliminisani.update(gubitnik for _, gubitnik in trenutni_krug)
        preostali_igraci = [igrac for igrac in trenutni_krug if igrac[0] not in eliminisani]

        if len(preostali_igraci) == 1:
            break

    output.append(str(pobednik))
    if drugoplasirani is not None:
        output.append(str(drugoplasirani))

    for igrac in preostali_igraci:
        output.append(str(igrac[0]))

    return output

# Unos podataka
k = int(input())
rezultati_turnira = [tuple(map(int, input().split())) for _ in range(2 ** k - 1)]

# Simulacija rezultata
rezultat = simuliraj_rezultate_turnira(k, rezultati_turnira)

# Ispisivanje rezultata
for linija in rezultat:
    if "(" not in linija:
        print(linija)
    else:
        print(linija[1])