def turnir_poredak(k, rezultati):
    takmicari = set(range(2**k))
    
    for i in range(1, k + 1):
        novi_takmicari = set()
        for j in range(0, len(takmicari), 2):
            igrac1, igrac2 = rezultati.pop(0)
            if igrac1 < igrac2:
                novi_takmicari.add(igrac2)
            else:
                novi_takmicari.add(igrac1)
        takmicari = novi_takmicari
    
    pobednik = takmicari.pop()
    drugoplasirani = takmicari.pop()

    print(pobednik)
    print(drugoplasirani)
    
    for i in range(k - 1, 0, -1):
        ispali = [igrac for igrac in range(2**k) if igrac not in takmicari and i in rezultati.pop(0)]
        ispali.sort()
        print(" ".join(map(str, ispali)))

# Ucitavanje ulaza
k = int(input())
rezultati = [tuple(map(int, input().split())) for _ in range(2**k - 1)]

# Poziv funkcije i ispis rezultata
turnir_poredak(k, rezultati)