def moze_kvadrat(shibice):
    ukupna_duzina = sum(shibice)
    
    # Provera da li je ukupna dužina deljiva sa 4
    if ukupna_duzina % 4 != 0:
        return 0
    
    # Sortiranje šibica od najduže ka najkrace
    shibice.sort(reverse=True)
    
    # Pomocna funkcija za rekurzivnu proveru
    def rekurzija(trenutna_strana, indeks):
        # Ako smo dosli do kraja liste, svi kvadrati su postavljeni
        if indeks == len(shibice):
            return 1
        
        # Prolazimo kroz sve šibice
        for i in range(len(trenutna_strana)):
            # Ako trenutna šibica može da se postavi na trenutnu stranu
            if trenutna_strana[i] >= shibice[indeks]:
                # Kopiramo trenutnu stranu
                nova_strana = list(trenutna_strana)
                # Postavljamo trenutnu šibicu
                nova_strana[i] -= shibice[indeks]
                # Rekurzivno pozivamo za sledecu šibicu
                rezultat = rekurzija(nova_strana, indeks + 1)
                # Ako je rezultat 1, vracamo 1
                if rezultat:
                    return 1
        
        # Ako ne možemo postaviti trenutnu šibicu ni na jednu stranu, vracamo 0
        return 0
    
    # Inicijalizacija strana kvadrata
    strane_kvadrata = [ukupna_duzina // 4] * 4
    # Rekurzivna provera
    rezultat = rekurzija(strane_kvadrata, 0)
    
    return rezultat

# Ucitavanje ulaza
n = int(input())
shibice_duzine = list(map(int, input().split()))

# Provera i ispis
rezultat = moze_kvadrat(shibice_duzine)
print(rezultat)