def rastojanje(lopta1, lopta2):
    y1, m1 = lopta1
    y2, m2 = lopta2
    return abs(y1 - y2)

def ukupna_distanca(putanja, lopte):
    distanca = 0
    for i in range(len(putanja) - 1):
        lopta1 = lopte[putanja[i]]
        lopta2 = lopte[putanja[i + 1]]
        distanca += rastojanje(lopta1, lopta2)
    return distanca

def generisi_permutacije(putanja, lopte, pos=0):
    global najmanja_distanca, najbolja_permutacija
    
    if pos == len(putanja):
        distanca = ukupna_distanca(putanja, lopte)
        if distanca < najmanja_distanca:
            najmanja_distanca = distanca
            najbolja_permutacija = putanja.copy()
        return
    
    for i in range(pos, len(putanja)):
        putanja[pos], putanja[i] = putanja[i], putanja[pos]
        generisi_permutacije(putanja, lopte, pos + 1)
        putanja[pos], putanja[i] = putanja[i], putanja[pos]

n = int(input())
lopte = [list(map(float, input().split())) for _ in range(n)]

najmanja_distanca = float('inf')
najbolja_permutacija = list(range(n))

generisi_permutacije(najbolja_permutacija, lopte)

print(*[x + 1 for x in najbolja_permutacija])