def min_bags_for_balance(weights):
    min_bags = float('inf')
    possible = False

    
    for comb in combinations(weights, 2):
        group_one_weight = sum(comb)
        group_two_weight = sum(weights) - group_one_weight
        weight_diff = abs(group_one_weight - group_two_weight)

        
        if weight_diff % 2 == 0:
            bags_needed = weight_diff // 2
            if bags_needed <= 4:
                possible = True
                min_bags = min(min_bags, bags_needed)

    return (possible, min_bags)


weights = [int(input()) for _ in range(4)]


possible, min_bags = min_bags_for_balance(weights)

if possible:
    print("da")
    print(min_bags)
else:
    print("ne")