def can_form_square(n, match_lengths):
    if n < 4:
        return 0
   
    perimeter = sum(match_lengths)
   
    if perimeter % 4 != 0:
        return 0
   
    side_length = perimeter // 4
   
    def check(index, sides):
        if index == n:
            return all(side == side_length for side in sides)
       
        for i in range(4):
            if sides[i] + match_lengths[index] <= side_length:
                sides[i] += match_lengths[index]
                if check(index + 1, sides):
                    return 1
                sides[i] -= match_lengths[index]
        return 0
   
    return check(0, [0, 0, 0, 0])

n = int(input())
match_lengths = list(map(int, input().split()))

result = can_form_square(n, match_lengths)
print(result)