def get_month_from_registration_number(registration_number):
    months = {
        '01': 'jan',
        '02': 'feb',
        '03': 'mar',
        '04': 'apr',
        '05': 'maj',
        '06': 'jun',
        '07': 'jul',
        '08': 'avg',
        '09': 'sep',
        '10': 'okt',
        '11': 'nov',
        '12': 'dec'
    }

    month_digits = registration_number[2:4]
    if month_digits in months:
        return months[month_digits]
    else:
        return "Invalid month"


social_security_number = input("")


month_of_birth = get_month_from_registration_number(social_security_number)

print(month_of_birth)