def moze_formirati_kvadrat(n, duzine):
    ukupna_duzina = sum(duzine)
    if ukupna_duzina % 4 != 0:
        return 0
    
    duzine.sort(reverse=True)
    ivice = [0] * 4

    def dfs(index):
        if index == n:
            return 1

        for i in range(4):
            if ivice[i] + duzine[index] <= ukupna_duzina // 4:
                ivice[i] += duzine[index]
                if dfs(index + 1):
                    return 1
                ivice[i] -= duzine[index]

        return 0

    return dfs(0)

n = int(input())
duzine = list(map(int, input().split()))
print(moze_formirati_kvadrat(n, duzine))