import time
import sys

debug = False

if debug:
    sys.stdin = open("my_tests\\6\\3.txt")


def udaljenost(lopta1, lopta2):
    return ((lopta1[0] - lopta2[0]) ** 2 + (lopta1[1] - lopta2[1]) ** 2) ** 0.5


def ukupna_udaljenost(redosled, lopte):
    distanca = 0
    for i in range(len(redosled) - 1):
        distanca += udaljenost(lopte[redosled[i]], lopte[redosled[i + 1]])
    return distanca


def najkraca_udaljenost(redosled, lopte):
    najkraca_distanca = float("inf")
    najbolji_redosled = None
    sve_kombinacije = kombinacije(
        redosled
    )  # Koristi itertools biblioteku da dobije sve permutacije
    for komb in sve_kombinacije:
        distanca = ukupna_udaljenost(
            komb, lopte
        )  # Izracunava distance medju svim loptama redom
        if distanca < najkraca_distanca:
            najkraca_distanca = distanca
            najbolji_redosled = komb
    return najbolji_redosled


best_cost = float("inf")

new_var = []


def get_permutations(available, route, cost, best_route):
    global best_cost
    global lopte
    global new_var
    if len(available) == 0:
        if cost < best_cost and len(route) == len(best_route):
            best_cost = cost
            best_route = route
            new_var = best_route.copy()
        return best_route

    for i in range(len(available)):
        if len(route) == 0:
            val = 0
        else:
            val = udaljenost(lopte[route[-1]], lopte[available[i]])
        route.append(available[i])
        del available[i]
        cost += val
        if cost >= best_cost:
            cost -= val
            available.insert(i, route[-1])
            del route[-1]
            return best_route
        best_route = get_permutations(available, route, cost, best_route)
        cost -= val
        available.insert(i, route[-1])
        del route[-1]
    return best_route


def kombinacije(arr):
    kombi = itertools.permutations(arr, len(arr))

    return kombi


n = int(input())
lopte = []
allys0 = False
for i in range(n):
    l1 = input().split()
    lopte.append(
        [126 / float(l1[1]), float(l1[0])]
    )  # Calculates the x pos from weights and add it to list of balls. I is the index of the ball
    if float(l1[0]) != 0.0:
        allys0 = False

if allys0 == True:
    lopte.sort()
    for i in range(n):
        print(lopte[i][2] + 1)
    exit()


pocetni_redosled = []
for i in range(n):
    pocetni_redosled.append(i)

best_route = pocetni_redosled.copy()

get_permutations(pocetni_redosled, [], 0, pocetni_redosled.copy())
res = ""
for item in new_var:
    res += str(item + 1) + " "
print(res)