n = int(input())


sito = [1] * (n + 1)

for i in range(2, n + 1):
    if sito[i] == 1:
        for j in range(i, (n + 1) // i):
            sito[j * i] = 0


def factorise(n, sito):
    factors = []
    for i in range(2, n + 1):
        if sito[i] == 1:
            while n % i == 0:
                n = n / i
                factors.append(i)
    return factors


n_factors = factorise(n, sito)

otherNumber = 1

unique = list(set(n_factors))

for i in range(len(unique)):
    if n_factors.count(unique[i]) % 2 != 0:
        otherNumber *= unique[i]

print(otherNumber)