#include <iostream>

using namespace std;

long long findSmallestMultiplier(long long n) {
    for (long long m = 1; ; ++m) {
        long long product = n * m;

        long long divisors = 0;
        for (long long i = 1; i * i <= product; ++i) {
            if (product % i == 0) {
                if (i * i == product) {
                    divisors++;
                } else {
                    divisors += 2;
                }
            }
        }

        if (divisors % 2 == 1) {
            return m;
        }
    }
}

int main() {
    long long n;
    cin >> n;

    long long result = findSmallestMultiplier(n);

    cout << result << endl;

    return 0;
}