def razlozi_na_proste_cinioce(n):
    cinioci = []
    eksponenti = []
    i = 2
    
    while i * i <= n:
        if n % i:
            i += 1
        else:
            n //= i
            count = 1
            
            while n % i == 0:
                n //= i
                count += 1
            
            cinioci.append(i)
            eksponenti.append(count)
    
    if n > 1:
        cinioci.append(n)
        eksponenti.append(1)
    
    return cinioci, eksponenti

def neparan_broj_delilaca(broj):
    _, eksponenti = razlozi_na_proste_cinioce(broj)
    neparan_broj_delilaca = 1
    
    for eksponent in eksponenti:
        neparan_broj_delilaca *= eksponent + 1
    
    return neparan_broj_delilaca

def najmanji_m_za_neparan_broj_delilaca(n):
    m = 1
    while neparan_broj_delilaca(n * m) % 2 == 0:
        m += 1
    return m


n = int(input())
m = najmanji_m_za_neparan_broj_delilaca(n)
print(m)