def najmanji_broj_m(n):
    # Funkcija koja vraca broj delilaca broja n
    def broj_delilaca(x):
        broj = 0
        for i in range(1, int(x**0.5) + 1):
            if x % i == 0:
                broj += 2  # Dodajemo i i x/i kao delioce
                if i == x // i:
                    broj -= 1  # Ako su i i x/i isti, smanjujemo za 1
        return broj

    # Tražimo najmanji broj m koji odgovara uslovima zadatka
    m = 1
    while True:
        if broj_delilaca(n * m) % 2 == 1:
            return m
        m += 1

# Citanje ulaznih podataka
n = int(input())

# Pozivanje funkcije i ispis rezultata
rezultat = najmanji_broj_m(n)
print(rezultat)