def minimalne_torbe(mase):
    # Racunamo zbir masa na obe strane
    zbir_levo = mase[0] + mase[1]
    zbir_desno = mase[2] + mase[3]

    # Proveravamo da li je ravnoteza vec postignuta
    if zbir_levo == zbir_desno:
        return "da\n0"

    # Proveravamo da li je moguce postici ravnotežu
    razlika = abs(zbir_levo - zbir_desno)
    if razlika % 2 == 1:
        return "ne"

    # Pronalazimo minimalan broj torbi
    broj_torbi = razlika // 2

    return f"da\n{broj_torbi}"

# Ucitavanje ulaza
mase = [int(input()) for _ in range(4)]

# Poziv funkcije i ispis rezultata
rezultat = minimalne_torbe(mase)
print(rezultat)