from itertools import combinations

# Unos podataka
n, k = map(int, input().split())
elements = list(map(int, input().split()))

# Sortiranje skupa elemenata
elements.sort()

# Racunanje najvece gustine
max_density = 0
max_density_subset = []

# Iteracija kroz sve moguce podskupove velicine k
for subset in combinations(elements, k):
    density = len(subset) / (subset[-1] - subset[0])
    
    # Ako je trenutni podskup gustiji od dosadašnjeg maksimuma
    if density > max_density:
        max_density = density
        max_density_subset = subset

# Ispis rezultata
print(*max_density_subset)